# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.CreateCustomerRequest do
  @moduledoc """
  Request message to create a customer.

  ## Attributes

  *   `customer` (*type:* `GoogleApi.AndroidDeviceProvisioning.V1.Model.Company.t`, *default:* `nil`) - Required. The company data to populate the new customer. Must contain a
      value for `companyName` and at least one `owner_email` that's associated
      with a Google Account. The values for `companyId` and `name` must be empty.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :customer => GoogleApi.AndroidDeviceProvisioning.V1.Model.Company.t()
        }

  field(:customer, as: GoogleApi.AndroidDeviceProvisioning.V1.Model.Company)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.CreateCustomerRequest do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.CreateCustomerRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.CreateCustomerRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
