# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.CustomerApplyConfigurationRequest do
  @moduledoc """
  Request message for customer to assign a configuration to device.

  ## Attributes

  *   `configuration` (*type:* `String.t`, *default:* `nil`) - Required. The configuration applied to the device in the format
      `customers/[CUSTOMER_ID]/configurations/[CONFIGURATION_ID]`.
  *   `device` (*type:* `GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceReference.t`, *default:* `nil`) - Required. The device the configuration is applied to.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :configuration => String.t(),
          :device => GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceReference.t()
        }

  field(:configuration)
  field(:device, as: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceReference)
end

defimpl Poison.Decoder,
  for: GoogleApi.AndroidDeviceProvisioning.V1.Model.CustomerApplyConfigurationRequest do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.CustomerApplyConfigurationRequest.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.AndroidDeviceProvisioning.V1.Model.CustomerApplyConfigurationRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
