# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.DevicesLongRunningOperationResponse do
  @moduledoc """
  Tracks the status of a long-running operation to claim, unclaim, or attach
  metadata to devices. To learn more, read
  [Long‑running batch operations](/zero-touch/guides/how-it-works#operations).

  ## Attributes

  *   `perDeviceStatus` (*type:* `list(GoogleApi.AndroidDeviceProvisioning.V1.Model.OperationPerDevice.t)`, *default:* `nil`) - The processing status for each device in the operation.
      One `PerDeviceStatus` per device. The list order matches the items in the
      original request.
  *   `successCount` (*type:* `integer()`, *default:* `nil`) - A summary of how many items in the operation the server processed
      successfully. Updated as the operation progresses.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :perDeviceStatus =>
            list(GoogleApi.AndroidDeviceProvisioning.V1.Model.OperationPerDevice.t()),
          :successCount => integer()
        }

  field(
    :perDeviceStatus,
    as: GoogleApi.AndroidDeviceProvisioning.V1.Model.OperationPerDevice,
    type: :list
  )

  field(:successCount)
end

defimpl Poison.Decoder,
  for: GoogleApi.AndroidDeviceProvisioning.V1.Model.DevicesLongRunningOperationResponse do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.DevicesLongRunningOperationResponse.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.AndroidDeviceProvisioning.V1.Model.DevicesLongRunningOperationResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
